test_runner: link_test_objects

include buildTools.make
include unit_test_paths.make

CXXFLAGS = -g3 -O0 -Wall -Wno-sign-compare
#-fprofile-arcs -ftest-coverage

ODEMX_CONFIG = -DODEMX_USE_OBSERVATION -DODEMX_USE_TRACE -DODEMX_USE_CONTINUOUS

LIBS = \
-lUnitTest++ \
-lOdemXT \
-lPocoSQLited \
-lPocoDatad \
-lPocoXMLd \
-lPocoFoundationd \
-lgcov \
-liphlpapi

VPATH:=$(VPATH):../test/Main
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/Main/%.cpp, %.o, $(wildcard ../test/Main/*.cpp))

VPATH:=$(VPATH):../test/TestBase
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/TestBase/%.cpp, %.o, $(wildcard ../test/TestBase/*.cpp))

VPATH:=$(VPATH):../test/TestCoroutine
UT_OBJECTS:=$(UT_OBJECTS)	$(patsubst ../test/TestCoroutine/%.cpp, %.o, $(wildcard ../test/TestCoroutine/*.cpp))

VPATH:=$(VPATH):../test/TestData
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/TestData/%.cpp, %.o, $(wildcard ../test/TestData/*.cpp))

VPATH:=$(VPATH):../test/TestData/TestBuffer
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/TestData/TestBuffer/%.cpp, %.o, $(wildcard ../test/TestData/TestBuffer/*.cpp))

VPATH:=$(VPATH):../test/TestData/TestOutput
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/TestData/TestOutput/%.cpp, %.o, $(wildcard ../test/TestData/TestOutput/*.cpp))

VPATH:=$(VPATH):../test/TestProtocol
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/TestProtocol/%.cpp, %.o, $(wildcard ../test/TestProtocol/*.cpp))

VPATH:=$(VPATH):../test/TestRandom
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/TestRandom/%.cpp, %.o, $(wildcard ../test/TestRandom/*.cpp))

VPATH:=$(VPATH):../test/TestStatistics
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/TestStatistics/%.cpp, %.o, $(wildcard ../test/TestStatistics/*.cpp))

VPATH:=$(VPATH):../test/TestSynchronization
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/TestSynchronization/%.cpp, %.o, $(wildcard ../test/TestSynchronization/*.cpp))

VPATH:=$(VPATH):../test/TestUtil
UT_OBJECTS:=$(UT_OBJECTS) $(patsubst ../test/TestUtil/%.cpp, %.o, $(wildcard ../test/TestUtil/*.cpp))

link_test_objects: test_objects
	@rm -rf Test/test_runner
	@rm -rf *.gcda
	@@if ! test -f error.log; then \
	$(CXX) $(LIB_PATHS) Test/Objects/*.o -o Test/test_runner $(LIBS); \
	fi

test_objects : $(patsubst %.o, Test/Objects/%.o, $(UT_OBJECTS))
	@if test -f error.log -a ! -s error.log; then rm error.log; fi
	@if test -f error.log;\
	then echo; echo There where errors during build process:; echo;\
	cat error.log;\
	echo; echo see error.log for details; echo;\
	fi

Test/Objects/%.o : %.cpp
	@echo Compile $< to target $@
	@$(CXX) -c $(CXXFLAGS) $(ODEMX_CONFIG) $(INCLUDEPATHS) -I$(UNIT_TEST_PP_INCLUDE_PATH) $< -o $@ 2>>error.log || cat error.log
